/*******************************************************************
 * GEB definitions
 * --- -----------
 *
 * WARNING: DO NOT CHANGE THIS FILE
 *
 * Public interface definitions for GEB Automation lib
 *
 ********************************************************************/

#ifndef _GEBC_HEADER_H_
#define _GEBC_HEADER_H_

#ifdef __cplusplus
extern "C" {
#endif

//#define malloc MyMalloc

#include <stdio.h>
#include <stdlib.h>

//#include "gebarch.h"
//#include "gebdrv.h"
//#include "gebtime.h"

void *MyMalloc(size_t size);

typedef char int8;
typedef unsigned char BYTE;
typedef unsigned char uint8;
typedef int int16;
typedef unsigned short uint16;
typedef unsigned short WORD;
typedef long int32;
typedef unsigned long uint32;
typedef unsigned long DWORD;
/**   * @brief  RTC Time structure definition    */
typedef struct
{
  BYTE RTC_Hours;    /*!< Specifies the RTC Time Hour.*/
  BYTE RTC_Minutes;  /*!< Specifies the RTC Time Minutes.*/
  BYTE RTC_Seconds;  ///*!< Specifies the RTC Time Seconds.
  BYTE RTC_H12;      //*!< Specifies the RTC AM/PM Time.
}RTC_TimeTypeDef; 

/**  * @brief  RTC Date structure definition   */
typedef struct
{
  BYTE RTC_WeekDay; 
  BYTE RTC_Month;   
  BYTE RTC_Date;    
  BYTE RTC_Year;    
}RTC_DateTypeDef;

typedef  void (*pFunctionTask)();
#define MAXTASK 1
typedef struct
	{
	DWORD		Action;
	DWORD		Addr;
	DWORD		Vali;
	float		Valf;
	DWORD		Error;
	pFunctionTask GetTs;
	pFunctionTask GetTi;
	pFunctionTask SetTs;
	pFunctionTask SetTi;
	BYTE 		*TaskName;
	DWORD 	BlkVals[8];
	DWORD		BlkInit;
	DWORD		BlkChg;
	unsigned long long	TaskTimer;
	RTC_TimeTypeDef   	*RTC_Time;
	RTC_DateTypeDef   	*RTC_Date;
	DWORD		NumberTask;
	DWORD		TU_active;
	} IEC61131_LINK;

/******************************************************************************************************/

#ifdef __cplusplus
}
#endif

#endif
