
#include "geb.h"

IEC61131_LINK TLink __attribute__((section(".common")));

#include "Vers.c"

void UserProgrammCycle(void);

void __attribute__ ((weak)) _init(void) {}

// спец функции
#define CLEAR_ERROR() VAR_ERROR = 0;

// спец типы переменных
#define VAR_TI float
#define VAR_TS DWORD
#define VARTI float
#define VARTS DWORD

// спец значения
#define SET_OK 0
#define SET_ERROR 1
#define AUTO 5
#define AUTOCLEAR 6
#define OK 0
#define ERROR 1
#define TS_ON 1
#define TS_OFF 0
#define DPTS_INTERMEDIATE 1
#define DPTS_ON 2
#define DPTS_OFF 1
#define DPTS_INDETERMINATE 3

// спец переменные
#define VAR_ERROR TLink.Error
#define TIMER_MC TLink.TaskTimer
#define TIME_HOUR   (WORD)TLink.RTC_Time->RTC_Hours
#define TIME_MIN    (WORD)TLink.RTC_Time->RTC_Minutes
#define TIME_SEC    (WORD)TLink.RTC_Time->RTC_Seconds


void InitTasks(void) {
    if (TLink.Action > MAXTASK) return;
    if (TLink.Action == 0) {
        TLink.TaskName = (void *) VersC;

        TLink.NumberTask = 1; //одна на "с"
        TLink.BlkChg = 0;
        TLink.BlkInit = 0;
        TLink.Error = 0;
        TLink.TU_active = 0;
        TLink.BlkVals[0] = 0;
        TLink.BlkVals[1] = 0;
        TLink.BlkVals[2] = 0;
        TLink.BlkVals[3] = 0;
        TLink.BlkVals[4] = 0;
        TLink.BlkVals[5] = 0;
        TLink.BlkVals[6] = 0;
        TLink.BlkVals[7] = 0;
		deviceInit();
    } else {
        UserProgrammCycle();
    }
}

void NMI_Handler() { // точка запуска из основного цикла
    InitTasks();
}

int main(void) {
    TLink.Action = 0;
    InitTasks();
}

//------------------------------------------------------------------
// функции телеметрии

// установить однопозиционный ТС	
void TS_WRITE(int adr, DWORD val, int err) {
    TLink.Addr = adr - 1;
    TLink.Vali = val;
    if (err <= ERROR) {
        TLink.Error = err;
        TLink.SetTs();
    } else {
        TLink.SetTs();
        if( err == AUTOCLEAR ) TLink.Error = 0;
    }
}

// установить двухпозиционный ТС	
void TS_DP_WRITE(int adr, DWORD val, int err) {
    TLink.Addr = adr - 1;
    TLink.Vali = val | 0x80;
    if (err <= ERROR) {
        TLink.Error = err;
        TLink.SetTs();
    } else {
        TLink.SetTs();
        if( err == AUTOCLEAR ) TLink.Error = 0;
    }
}

// читаем тс, для любого на выходе 0/1
DWORD TS_READ(int adr) {
    TLink.Addr = adr - 1;
    TLink.GetTs();
    if (TLink.Vali & 0x80) {
        //двухпозиционный
        if ((TLink.Vali & 0x3) == 0x3) TLink.Error = 1;
        else if ((TLink.Vali & 0x3) == 0x0) TLink.Error = 1;
        else if ((TLink.Vali & 0x3) == 0x1) TLink.Vali = 0;
        else if ((TLink.Vali & 0x3) == 0x2) TLink.Vali = 1;
    }

    return TLink.Vali & 1;
}

// читаем двухпозиционный, для любого на выходе 0/1/2/3
DWORD TS_DP_READ(int adr) {
    TLink.Addr = adr - 1;
    TLink.GetTs();
    if (TLink.Vali & 0x80) {    //двухпозиционный
    } else  {
        TLink.Vali = (TLink.Vali & 1) ? 2 : 1;
    }

    return TLink.Vali & 3;
}

void TI_WRITE(int adr, float val, DWORD err) {
    TLink.Addr = adr - 1;
    TLink.Valf = val;
    if (err <= ERROR) {
        TLink.Error = err;
		TLink.SetTi();
    } else {
		TLink.SetTi();
        if( err == AUTOCLEAR ) TLink.Error = 0;
    }
}

float TI_READ(int adr) {
    TLink.Addr = adr - 1;
    TLink.GetTi();
    return TLink.Valf;
}

void SET_OUT(int adr, DWORD val) {
    DWORD i;
    adr--;
    TLink.BlkInit |= 1 << (adr / 32);
    i = (TLink.BlkVals[adr / 32] & (1 << (adr % 32))) > 0;
    if (val != i) {
        TLink.BlkChg |= 1 << (adr / 32);
        if (val)
            TLink.BlkVals[adr / 32] |= (1 << (adr % 32));
        else
            TLink.BlkVals[adr / 32] &= ~(1 << (adr % 32));
    }
}

void MAKE_TU(int adr, DWORD val) {
	TS_WRITE( 10000 + adr, val, 0 );
}

int PrintText( char *text )
{
	TLink.Addr = 5001;
	TLink.Vali = (DWORD)text;
	TLink.GetTs();
}

int PrintData( DWORD data )
{
	TLink.Addr = 5002;
	TLink.Vali = data;
	TLink.GetTs();
}

/****************************************************************************************/

#include "user_task.c"

