// место задания глобальный переменных
// ТИП ИМЯ;
// для измерений 
// VAR_TI ValueAnalogA;
// для телесигналов
// VAR_TS BreakerA;

VAR_TI ValueAnalog;
VAR_TS Signal_4, Signal_5;

void deviceInit() {
// Тут можно задать значения переменных при включении контроллера

    Signal_4 = TS_ON;
    ValueAnalog = 0;
}

void UserProgrammCycle() {   
// Тут пишем программу которая будет запускаться по заданному циклу

    CLEAR_ERROR()    // сброс признака ошибки возникающей при чтении недостоверных телепараметров

// пример работы с ТИ
    ValueAnalog = TI_READ(1) + TI_READ(2) + TI_READ(3);    // сумма трех ТИ с адресами 1 2 и 3

    TI_WRITE(15, ValueAnalog, VAR_ERROR);    // запись ТИ 15 результата с учетом наличия ошибки
    // т.е. если хоть один из трех параметров был недостоверным то и результат станет недостоверным
    //	TI_WRITE( 15, ValueAnalog, OK );	// запись ТИ 15 результата всегда достоверным
    //	TI_WRITE( 15, ValueAnalog, ERROR );	// запись ТИ 15 результата всегда недостоверным
    // тоже самое действие можно записать как явная проверка
    if (VAR_ERROR) TI_WRITE(15, ValueAnalog, ERROR);
    else TI_WRITE(15, ValueAnalog, OK);

    // внимание! запись типа
    // TI_WRITE( 15, TI_READ(1)+TI_READ(2)+TI_READ(3), VAR_ERROR );
    // будет некорректной поскольку значение VAR_ERROR будет использовано до операций доступа
    // 	к ТИ1-3 и не будет отражать реальную достоверность этих параметров
    // т.е. расчет будет правильным, но без учета достоверности

    CLEAR_ERROR();    //сброс ошибки для следующих операций

// пример работы с ТС
// проверяем если ТС4 и ТС5 включены то делаем ТС3 включенным иначе ТС3 = выключено
// обратите внимание что отдельные условия в операторе if нужно закрывать 
// скобками для задания явного приоритета операций
    if ((TS_READ(4) == TS_ON) && (TS_READ(5) == TS_ON)) { // если оба включены
        TS_WRITE(3, TS_ON, VAR_ERROR);
    } else {    // если хоть один выключен
        TS_WRITE(3, TS_OFF, VAR_ERROR);
    }
    CLEAR_ERROR();    //сброс ошибки для следующих операций

    // тоже самое по другому можно сделать

    Signal_4 = TS_READ(4);
    Signal_5 = TS_READ(5);
    if (Signal_4 & Signal_5) TS_WRITE(3, TS_ON, VAR_ERROR);
    else TS_WRITE(3, TS_OFF, VAR_ERROR);
    CLEAR_ERROR();

    // тоже самое по другому можно сделать
    Signal_4 = TS_READ(4);
    Signal_5 = TS_READ(5);
    TS_WRITE(3, Signal_4 & Signal_5, VAR_ERROR);
    CLEAR_ERROR();

// сделать двухпозиционный ТС из двух однопозиционных
    TS_DP_WRITE(3, TS_READ(4) + (TS_READ(5) * 2), AUTOCLEAR);

// пример работы со временем
// есть доступные переменные содержащие текущее время
// TIME_HOUR  текущий час
// TIME_MIN текущая минута
// TIME_SEC текущая секунда
// ниже запись в ТИ с адресом 16  значения текущей секуды в часе
    TI_WRITE(16, (TIME_MIN * 60) + TIME_SEC, SET_OK);
}
